package ehu.student.collections;

import java.util.ArrayList;
import java.util.TreeSet;

public class Permutador4ArrayListStringTester {

    private Permutador4ArrayListString permutador =
        new Permutador4ArrayListString();
    
    public void testCombinar(){
        ArrayList<String> l = new ArrayList<String>();
        ArrayList<ArrayList<String>> r = permutador.combinar(l, "java");
        if (r.size() != 1 || r.get(0).size() != 1 || !r.get(0).get(0).equals("java"))
            {
                throw new RuntimeException(permutador.toString(r));
            }
        l.add("java");
        r = permutador.combinar(l, "C++");
        if (r.size() != 2 || r.get(0).size() != 2 || r.get(1).size() != 2
            || !r.get(0).contains("java") || !r.get(0).contains("C++")
            || !r.get(1).contains("java") || !r.get(1).contains("C++"))
            {
                throw new RuntimeException(permutador.toString(r));
            }
    }
    
    public void testExtend(){
        ArrayList<ArrayList<String>> l = new ArrayList<ArrayList<String>>();
        l.add(new ArrayList<String>());
        ArrayList<ArrayList<String>> r = permutador.extender(l, "java");
        if (r.size() != 1 || r.get(0).size() != 1 || !r.get(0).get(0).equals("java"))
            {
                throw new RuntimeException(permutador.toString(r));
            }
        r = permutador.extender(r, "C++");      
        if (r.size() != 2 || r.get(0).size() != 2 || r.get(1).size() != 2
            || !r.get(0).contains("java") || !r.get(0).contains("C++")
            || !r.get(1).contains("java") || !r.get(1).contains("C++"))
            {
                throw new RuntimeException(permutador.toString(r));
            }
    }       

    public void testPermute(){
        TreeSet<String> set = new TreeSet<String>();
        set.add("java");
        ArrayList<ArrayList<String>> l = new ArrayList<ArrayList<String>>();
        l.add(new ArrayList<String>());
        ArrayList<ArrayList<String>> r = permutador.permutar(set);
        if (r.size() != 1 || r.get(0).size() != 1 || !r.get(0).get(0).equals("java"))
            {
                throw new RuntimeException(permutador.toString(r));
            }
        set.add("java");
        set.add("C++");
        r = permutador.permutar(set);           
        if (r.size() != 2 || r.get(0).size() != 2 || r.get(1).size() != 2
            || !r.get(0).contains("java") || !r.get(0).contains("C++")
            || !r.get(1).contains("java") || !r.get(1).contains("C++"))
            {
                throw new RuntimeException(permutador.toString(r));
            }
    }
    
    public void run(){
        testCombinar();
        testExtend();
        testPermute();
    }
    
    public static void main(String[] args) {
        new Permutador4ArrayListStringTester().run();
    }
}
